program denscomp
version 10.0
syntax varname(numeric) [if] [in], by(varname) at(varname numeric) ///
[TItle(string asis) YTItle(string asis) XTItle(string asis) * ]
marksample touse

// Store levels of By-Variable
quietly levelsof `by' if `touse', local(K)

// Check Graph-Options
if "`options'" ~= "" {
	foreach k of local K {
		tempvar g`k'
		quitely gen `g`k'' = `by'==`k' if `by' < . & `touse'
		local G "`G' `g`k''"
	}
	graph twoway scatter `G' `at', `options' nodraw
}

// Calculate Kernel-Densities
local i 1
foreach k of local K {
	tempvar fx`k' xvals`k'
	kdensity `varlist' if `by'==`k' & `touse', gen(`xvals`k'' `fx`k'') at(`at') nograph
	local yvars "`yvars' fx`k'"
	local label: label (`by') `k'
	local leglab `" `leglab' label(`i++' `"`label'"') "'
}

// Graph-Defaults
local title = cond(`"`title'"' == `""', `"`varlist' by `by'"', `"`title'"')
local ytitle = cond(`"`ytitle'"' == `""', `"Density"', `"`ytitle'"')
local xtitle = cond(`"`xtitle'"' == `""', `"`varname'"', `"`xtitle'"')

// Display the Graph
graph twoway connected `yvars' `at' ///
, title(`title') ytitle(`ytitle') xtitle(`xtitle') legend(`leglab') `options'
end
exit
